% # variable:
% # bookshelf, bookuuid, current_uuid, record_name, info, eznav_level, stnav_level

% import xml.etree.ElementTree as ET

% # 整理並抽取基本資料
% try:
    % book = bookshelf.findbook(bookuuid)
    % bookxml = book.book_xml()
    % ebook = ET.fromstring(bookxml)

    % enote = ebook.find('.//note[@uuid="{}"]'.format(current_uuid))
    % if enote is None and bookuuid == current_uuid:
        % enote = ebook
    % end

    % # enote 存在（有效），則計算與歷史記錄有關的項目
    % if enote is not None:
        % mtime = book.mtime(current_uuid)
        % ehistory = bookshelf.ehistory(bookuuid, current_uuid)
    % end
% except:
    % book = None
    % ebook = None
    % enote = None
% end


<aside id="sidebar">

    <nav id="pagenav">
        <!-- eznav -->
        % if enote is not None:
            % include ez_nav book = book, ebook = ebook, target_uuid = current_uuid, max_level = eznav_level
        % else:
            <ul class="menuroot">
                <li><a href="/last" title="Back to the note page which your browsing before." target="">Back<span class="notify"><img class="icon" src="/static/icon/sidebar/move.svg"></span></a>
            </ul>
        % end

        <!-- Nav -->
        % ebooks = bookshelf.ebooks()

        <ul class="menuroot">
            <li class="stnav"><a href="/index" title="Want to see your notes index?" target="">Bookshelf<span class="notify"><img class="icon" src="/static/icon/sidebar/index.svg"></span></a>
            <ul>
                % for ebook in ebooks:
                    % if bookuuid is not None and ebook.get('uuid') == bookuuid:
                        % include nav_item book = bookshelf.findbook(ebook.get('uuid')), eroot = ebook, bookuuid = ebook.get('uuid'), target_uuid = current_uuid, max_level = stnav_level, trace_path_enable = True
                    % else:
                        % include nav_item book = bookshelf.findbook(ebook.get('uuid')), eroot = ebook, bookuuid = ebook.get('uuid'), target_uuid = current_uuid, max_level = stnav_level, trace_path_enable = False
                    % end
                % end
            </ul>
        </ul>
    </nav>
    <hr />

    <nav id="commandnav">
        <!-- Configure Menu -->
        <ul class="menuroot">
            <li><a href="/config" title="Configure & Manage your LoNote server.">Configure<span class="notify"><img class="icon" src="/static/icon/sidebar/config.svg"></span></a>
                <ul>
                    % if bookuuid:
                        <li><a href="/config/book/{{!bookuuid}}" title="Configure & Manage this book.">Configure This Book<span class="notify"><img class="icon" src="/static/icon/sidebar/config.svg"></span></a></li>
                    % end
                    <li><a href="/static/page/hotkey.html" title="Check Hotkey table." target="_blank">Hot Key<span class="notify"><img class="icon" src="/static/icon/sidebar/hotkey.svg"></span></a></li>
                    <!-- <li><a href="/start" title="Beginner start page.">How to Start<span class="notify"><img class="icon" src="/static/icon/sidebar/howtostart.svg"></span></a></li> -->
                    <li><a href="{{!info.homepage}}" title="Check about the LoNote Project" target="_blank">About LoNote<span class="notify"><img class="icon" src="/static/icon/sidebar/about.svg"></a></span>
                        <ul>
                            <li><a href="{{!info.changelogpage}}" target="_blank"title="Check the LoNote's Changelog">Version: <b>{{!info.version}}</b></a></li>
                            <li><a href="{{!info.bugpage}}" target="_blank" title="Check or submit your bugs or feature request."><b>Bug Report</b></a></li>
                            <li><a href="{{!info.forumpage}}" target="_blank" title="Talk something about LoNote."><b>Forum</b></a></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>

        <!-- 歷史記錄 -->
        % if enote is not None:
            <hr />
            % include record_menu ehistory = ehistory, mtime = mtime, record_name =record_name
        % end

        <!-- 編輯／瀏覽按鈕 -->
        % if enote is not None:
            <ul class="menuroot">
                <li><a id="content-mode" title="toggle by click"></a>
                    <ul>
                        <li><a href="?mode=html" title="Show this page as a complete HTML page include CSS and other things, but no sidebar and edit function.">HTML Mode</a></li>
                        <li><a href="?mode=raw" title='Show only the "pure content" which you edited in this page.'>Raw Mode</a></li>
                    </ul>
                </li>
            </ul>
        % end


        <!--功能選單面板-->
        % if enote is not None:
            <hr />
            <div id="cmdpanel">
                <ul class="menuroot">
                    <li id="btn_content_update"><a title="Save as the current version.">Save<span class="notify"><span class="response_notify"></span><img class="icon" src="/static/icon/sidebar/save.svg"></span></a>
                        <ul>
                            <li id="btn_note_create"><a title="Create a new note">New Note<span class="notify"><img class="icon" src="/static/icon/sidebar/newnote.svg"></span></a></li>
                            <li id="btn_title_update"><a title="Change the title.">Change Title<span class="notify"><img class="icon" src="/static/icon/sidebar/changetitle.svg"></span></a></li>
                            <li id="btn_position_update"><a title="Move the current note position.">Move<span class="notify"><img class="icon" src="/static/icon/sidebar/move.svg"></span></a></li>
                            <li id="btn_make_record"><a title="Freeze the current version as a record.">Freeze Version<span class="notify"><span class="response_notify"></span><img class="icon" src="/static/icon/sidebar/version.svg"></span></a></li>
                            <li id="btn_clear_unused_embedded"><a title="Clear (embedded) resources which not appear in current or any records content.">Clear Unused Resource<span class="notify"><img class="icon" src="/static/icon/sidebar/clearunusedemb.svg"></span></a></li>
                            <li id="btn_note_delete"><a title="Delete the current page.">Recycle<span class="notify"><img class="icon" src="/static/icon/sidebar/recycle.svg"></span></a></li>
                            <li id="btn_note_export"><a title="Export the current page (and all sub pages) as a new Notebook.">Export<span class="notify"><img class="icon" src="/static/icon/sidebar/export.svg"></span></a></li>
                            <!-- <li id="btn_book_import" title="Import a existing notebook as sub-page of current note."><a>Import<span class="notify"><img class="icon" src="/static/icon/sidebar/import.svg"></span></a></li> -->
                        </ul>
                    </li>

                    <!-- 資源列表 -->
                    <li id="resource_list"><a title="All page resource are listed here..." style="cursor: default;">Resource<span class="notify"><img class="icon" src="/static/icon/sidebar/resource.svg"></span></a>
                        <ul>
                            % resource_list = book.resource_list(current_uuid)
                            % for resource in resource_list:
                                %if resource.get('res_type') == 'emb':
                                    %icon = ' <img class="icon" src="/static/icon/sidebar/emb.svg">'
                                %elif resource.get('res_type') == 'att':
                                    %icon = ' <img class="icon" src="/static/icon/sidebar/att.svg">'
                                %else:
                                    %icon = ''
                                %end
                                <li res_name="{{resource.get('name')}}"><a class="resource_link" href="{{resource.get('name')}}" title="" target="_blank"><span class="notify-small">{{!icon}}</span>{{resource.get('name')}}</a>
                                    <ul>
                                        <li onclick="lo.noteop.resource_del_dia('{{resource.get("name")}}');"><a title='Delete: <b>{{resource.get('name')}}</b>'>delete</a></li>
                                    </ul>
                                </li>
                            %end
                        </ul>
                    </li>
                </ul>
            </div>
        %end

    </nav>


    <script>
        // 掛載 sidebar 所需的功能
        lo.sidebar.ready();
    </script>

    <script>
        $('#pagenav').tooltip({
            show: false,
            hide: false,
            position: { my: "left+15 top+15", at: "right bottom", collision: "flipfit" },
            content: function() {
                var title = $(this).attr('title');
                var h_list = $(this).parents().filter('li');
                var v_list = h_list.last().find(' ~ li');
                var v_texts = [];
                v_list.children('a').each(function(){v_texts.push($(this).text())});
                h_list = h_list.not('.stnav')
                var h_texts = [];
                h_list.children('a').each(function(){h_texts.push($(this).text())});
                h_texts.reverse();
                h_texts.pop();
                h_texts.reverse();
                // alert(v_texts.join(','));
                // alert(h_texts.join(','));
                var flowtext = $.merge(h_texts, v_texts).join(' ← ');
                flowtext = ' ← ' + flowtext;
                ans = '<b>' + $(this).text() + '</b><span style="font-size: smaller">' + flowtext + '</span><hr/>' + title;
                return ans;
            }
        });

        $('#commandnav').tooltip({
            show: false,
            hide: false,
            position: { my: "left+15 top+15", at: "right bottom", collision: "flipfit" },
            content: function() {
                var title = $(this).attr('title');
                var text = $(this).text();
                var ans = '<span style="font-size: smaller; font-style: italic;">' + text + '</span><hr/>' + title;
                return ans;
            }
        });

        $('#current_version').tooltip({
            show: false,
            hide: false,
            position: { my: "left+15 top+15", at: "right bottom", collision: "flipfit" }
        });

        $('.resource_link').tooltip({
            show: false,
            hide: false,
            track: true,
            position: { my: "left+15 top+15", at: "right bottom", collision: "flipfit" },
            content: function() {
                var path = $(this).attr('href');
                var ans = '';
                if(path.search(/\.(?:jpg|jpeg|gif|png|bmp|svg|webp)$/i) != -1){
                    ans = '<span style="font-size: smaller; font-style: italic;">' + path + '</span><hr/><img style="max-width: 200px; max-height: 200px;" src="' + path + '"/>';
                } else {
                    ans = '<span style="font-size: smaller; font-style: italic;">' + path + '</span>';
                }
                return ans;
            }
        });

    </script>


</aside>
